<?php
/**
* @version		1.5.0
* @package		Kunena Converters
* @subpackage	Kunena Converters
* @copyright	2009-2010 JoomAce LLC, www.joomace.net
* @license		GNU/GPL http://www.gnu.org/copyleft/gpl.html

* Some functions are based on Agora (jvitals.com) component's coverter.

*/

//No Permision
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.application.component.model');

define('QUERY_LIMIT', 100);

class KunenaConvertersModelKunenaConverters extends JModel {
	
	protected static $new_forums_ids = array();
	protected static $new_parents_ids = array();
	
	// Main constructer
	function __construct() {
		parent::__construct();
	}
	
	public function agora() {
		self::_truncateTables();
		self::_importAgoraUsers();
		self::_importAgoraForums();
		self::_importAgoraTopics();
		self::_importAgoraPosts();
		self::_updateLastMessageIDofCats();
		self::_importAgoraSubscriptions();
	}
	
	protected function _truncateTables() {
		$truncates = array();
		$truncates[] = 'TRUNCATE TABLE #__fb_categories';
		$truncates[] = 'TRUNCATE TABLE #__fb_messages';
		$truncates[] = 'TRUNCATE TABLE #__fb_messages_text';
		$truncates[] = 'TRUNCATE TABLE #__fb_subscriptions';
		$truncates[] = 'TRUNCATE TABLE #__fb_users';
		@reset($truncates);
		
		while(list( ,$sql) = @each($truncates)) {
			$this->_db->setQuery($sql);
			$this->_db->query();
		}
	}
	
	protected function _importAgoraUsers() {
		$offset = 0;
		
		do {
			$have_data = false;
			
			$this->_db->setQuery("SELECT * FROM #__agora_users ORDER BY jos_id LIMIT {$offset}, " . QUERY_LIMIT);
			$ob_list = $this->_db->loadAssocList();
			
			if (!empty($ob_list)) {
				$have_data = true;
			} else {
				break;
			}
			
			foreach ($ob_list as $ob) {
				// Data array
				$data = array(
					'userid' => $ob['jos_id'],
					'posts' => $ob['num_posts'],
					'signature'	=> $ob['signature'],
					'birthday' => $ob['birthdate'],
					'gender' => $ob['gender'],
					'location' => $ob['location'],
					'ICQ' => $ob['icq'],
					'AIM' => $ob['aim'],
					'MSN' => $ob['msn'],
					'SKYPE' => $ob['skype'],
					'websiteurl' => $ob['url']
				);
				
				$dir_ = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
				$members_av = $dir_.'/components/com_agora/img/members/'.$ob['jos_id'].'/'.$ob['jos_id'].'.png';
				$pre_av = $dir_.'/components/com_agora/img/pre_avatars/'.$ob['id'].'.png';
				
				if (JFile::exists($members_av)) {
					JFile::copy($members_av, $dir_.'/images/fbfiles/avatars/');
					$data['avatar'] = $ob['jos_id'].'.png';
				} elseif (JFile::exists($pre_av)) {
					JFile::copy($pre_av, $dir_.'/images/fbfiles/avatars/'.$ob['jos_id'].'.png');
					$data['avatar'] = $ob['jos_id'].'.png';
				}
				
				self::_insertData('fb_users', $data);
			}
			
			$offset += QUERY_LIMIT;
			
		} while ($have_data);		    		    
	}
	
	protected function _importAgoraForums() {
		$this->_db->setQuery("SELECT * FROM #__agora_categories ORDER BY id");
		$ob_list = $this->_db->loadAssocList();
		
		if (empty($ob_list)) {
			return;
		}
		
		foreach ($ob_list as $ob) {
			$data = array(
				'id' =>	$ob['id'],
				'name' => $ob['cat_name'],
				'published' => $ob['enable'],
				'parent' => '0',
				'ordering' => $ob['disp_position'],
				'pub_access' => '0',
				'pub_recurse' => '1',
				'admin_access' => '0',
				'admin_recurse' => '1'
			);
			
			self::_insertData('fb_categories', $data);
		}
		
		$this->_db->setQuery("SELECT * FROM #__agora_forums ORDER BY parent_forum_id, cat_id, id");
		$ob_list = $this->_db->loadAssocList();
		
		if (empty($ob_list)) {
			return;
		}
		
		foreach ($ob_list as $ob) {
			if ($ob['parent_forum_id'] == 0) {
				$parent = $ob['cat_id'];
			}
			elseif (isset(self::$new_forums_ids[$ob['parent_forum_id']])) {
				$parent = self::$new_forums_ids[$ob['parent_forum_id']];
			}
			else {
				continue;
			}
			
			// Data array
			$data = array(
				'name' => $ob['forum_name'],
				'description' => $ob['forum_desc'],
				'published' => $ob['enable'],
				'moderators' => $ob['moderators'],
				'parent' => $parent,
				'ordering' => $ob['disp_position'],
				'numTopics' => $ob['num_topics'],
				'numPosts' => $ob['num_posts'],
				'id_last_msg' => $ob['last_post_id'],
				'time_last_msg' => $ob['last_post'],
				'locked' => $ob['closed'],
				'pub_access' => '0',
				'pub_recurse' => '1',
				'admin_access' => '0',
				'admin_recurse' => '1'
			);
			
			$id = self::_insertdata('fb_categories', $data);
			self::$new_forums_ids[$ob['id']] = $id;
		}	    			    
	}
	
	protected function _importAgoraTopics() {	
		$offset = 0;
		
		do {
			$have_data = false;
			
			$fields = "id, subject, closed, sticky, moved_to, forum_id, num_views";
			$this->_db->setQuery("SELECT {$fields} FROM #__agora_topics ORDER BY id LIMIT {$offset}, " . QUERY_LIMIT);
			$topic_list = $this->_db->loadAssocList();

			if (!empty($topic_list)) {
				$have_data = true;
			} else {
				break;
			}

			foreach ($topic_list as $topic) {
				$fields = "p.poster, p.poster_id, p.poster_ip, p.poster_email, p.message, p.posted, p.edited, p.edited_by, u.jos_id, u.email";
				$this->_db->setQuery("SELECT {$fields} FROM #__agora_posts AS p, #__agora_users AS u WHERE p.topic_id = {$topic['id']} AND p.poster_id = u.id ORDER BY p.id ASC LIMIT 1");
				$post = $this->_db->loadAssoc();
			
				$email = $post['poster_email'];
				if ($email == 'null') {
					$email = $post['email'];
				}
				
				$catid = 0;
				if (isset(self::$new_forums_ids[$topic['forum_id']])) {
					$catid = self::$new_forums_ids[$topic['forum_id']];
				}
				
				unset($data);
				
				// Data array
				$data = array(
					'id' => $topic['id'],
					'parent' => 0,
					'thread' => $topic['id'],
					'catid' => $catid,
					'name' => $post['poster'],
					'userid' => $post['jos_id'],
					'email' => $email,
					'subject' => $topic['subject'],
					'time' => $post['posted'],
					'ip' => $post['poster_ip'],
					'locked' => $topic['closed'],
					'ordering' => $topic['sticky'],
					'hits' => $topic['num_views'],
					'moved' => $topic['moved_to'],
					'modified_by' => $post['edited_by'],
					'modified_time' => $post['edited']
				);

				self::_insertData('fb_messages', $data);
				
				unset($data);
				
				// Data array
				$data = array(
					'mesid' => $topic['id'],
					'message' => $post['message']
				);

				self::_insertData('fb_messages_text', $data);
			}
			
			$offset += QUERY_LIMIT;
			
		} while ($have_data);
	}
	
	protected function _importAgoraPosts() {	
		$offset = 0;
		
		$parents = array();
		
		do {
			$have_data = false;
			
			$fields = "p.poster, p.poster_id, p.poster_ip, p.poster_email, p.message, p.posted, p.edited, p.edited_by, p.topic_id, t.subject, t.closed, t.sticky, t.moved_to, t.forum_id, t.num_views, u.jos_id, u.email";
			$this->_db->setQuery("SELECT {$fields} FROM #__agora_posts AS p, #__agora_topics AS t, #__agora_users AS u WHERE p.topic_id = t.id AND p.poster_id = u.id ORDER BY p.id LIMIT {$offset}, " . QUERY_LIMIT);
			$ob_list = $this->_db->loadAssocList();

			if (!empty($ob_list)) {
				$have_data = true;
			} else {
				break;
			}

			foreach ($ob_list as $ob) {
				$email = $ob['poster_email'];
				if ($email == 'null') {
					$email = $ob['email'];
				}
				
				$catid = 0;
				if (isset(self::$new_forums_ids[$ob['forum_id']])) {
					$catid = self::$new_forums_ids[$ob['forum_id']];
				}
				
				if (!isset($parents[$ob['topic_id']])) {
					$parent = $ob['topic_id'];
				} else {
					$parent = $parents[$ob['topic_id']];
				}
				
				unset($data);
				
				// Data array
				$data = array(
					'parent' => $parent,
					'thread' => $ob['topic_id'],
					'catid' => $catid,
					'name' => $ob['poster'],
					'userid' => $ob['jos_id'],
					'email' => $email,
					'subject' => $ob['subject'],
					'time' => $ob['posted'],
					'ip' => $ob['poster_ip'],
					'locked' => $ob['closed'],
					'ordering' => $ob['sticky'],
					'hits' => $ob['num_views'],
					'moved' => $ob['moved_to'],
					'modified_by' => $ob['edited_by'],
					'modified_time' => $ob['edited']
				);

				$id = self::_insertData('fb_messages', $data);
				$parents[$ob['topic_id']] = $id;
				
				unset($data);
				
				// Data array
				$data = array(
					'mesid' => $id,
					'message' => $ob['message']
				);

				self::_insertData('fb_messages_text', $data);
			}
			
			$offset += QUERY_LIMIT;
			
		} while ($have_data);
	}
	
	protected function _updateLastMessageIDofCats() {
		$this->_db->setQuery("SELECT id FROM #__fb_categories");
		$catids = $this->_db->loadResultArray();
		
		if (!empty($catids)) {
			foreach ($catids as $catid) {
				$this->_db->setQuery("SELECT id FROM #__fb_messages WHERE catid = {$catid} ORDER BY id DESC LIMIT 1");
				$id_last_msg = $this->_db->loadResult();
				
				if (!empty($id_last_msg)) {
					$this->_db->setQuery("UPDATE #__fb_categories SET id_last_msg = '{$id_last_msg}' WHERE id = {$catid}");
					$this->_db->query();
				}
			}
		}
	}
	
	protected function _importAgoraSubscriptions() {
		$this->_db->setQuery("INSERT INTO #__fb_subscriptions (userid, thread) SELECT user_id, topic_id FROM  #__agora_subscriptions");
		$this->_db->query();
	}

	protected function _convertAttachement($message) {
		// Url -> [file name=changelog.txt size=9023]http://127.0.0.1/mediaconweb.it/images/fbfiles/files/changelog.txt[/file]
		$pattern = array('#\[file name=(.*?) size=[0-9]*\](.*?)\[/file\]#i');
		$replace = array('[url=$2]$1[/url]');

		return preg_replace($pattern, $replace, $message);
	}
	
	protected function _insertData($table, $data) {
		// Put together the query
		$names = array();
		$vars = array();

		foreach($data as $name => $var) {
			if ($var != '') {
				$names[] = $name;
				$var == 'null' ? $vars[] = $var : $vars[] = '\''.addslashes(stripslashes(self::_convertHTML($var))).'\'';
			}
		}
		
		$query = 'INSERT INTO #__'.$table.' ('.implode(',', $names).') VALUES ('.implode(',', $vars).')';
		$this->_db->setQuery($query);
		$this->_db->query();
		
		if ($this->_db->getErrorNum()) {
			throw new Exception(__METHOD__.' failed. ('.$this->_db->getErrorMsg().')');
		}
		
		return $this->_db->insertID();
	}
	
	protected function _convertHTML($message) {		
		$pattern = array(
		'/&gt;/i',
		'/&lt;/i',
		'/&amp;/i',
		'/&quot;/i',
		'/&#039;/i'
		);

		$replace = array(
		'>',
		'<',
		'&',
		'"',
		"'"
		);
		
		return preg_replace($pattern, $replace, $message);		
	}
	
	// Check info
	public function &getInfo() {
        $info = array();
		
        // Get installed version
        $info['version_installed'] = $this->getInstalledVersion();
       
        // Get latest version
        $info['version_latest'] = '?.?.?';
        $content = self::getRemoteData('http://www.joomace.net/index.php?option=com_aceversions&view=xml&format=xml&catid=6');
       
        if (strstr($content, '<?xml version="1.0" encoding="UTF-8" ?>')) {
			$xml =& JFactory::getXMLparser('Simple');
			$xml->loadString($content);
			
			$category = $xml->document->getElementByPath('category');
			
			foreach ($category->children() as $extension) {
				$option = $extension->attributes('option');
				if ($option == 'com_kunenaconverters') {
					$info['version_latest'] = trim($extension->attributes('version'));
					break;
				}
			}
		}
       
        // Set the version status
        $info['version_status'] = version_compare($info['version_installed'], $info['version_latest']);
        $info['version_enabled'] = 1;
       
        return $info;
    }

	protected function &getInstalledVersion()  {
        static $version;

        if (!isset($version)) {
            $xml = JFactory::getXMLParser('Simple');

            $xmlFile = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_kunenaconverters'.DS.'kunenaconverters.xml';

             if (JFile::exists($xmlFile)) {
                if ($xml->loadFile($xmlFile)) {
                    $root =& $xml->document;
                    $element =& $root->getElementByPath('version');
                    $version = $element ? $element->data() : '';
                }
            }
			
        }

        return $version;
    }
	
	protected function getRemoteData($url) {
		$useragent = "Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US; rv:1.9.1.3) Gecko/20090824 Firefox/3.5.3 (.NET CLR 3.5.30729)";
		$data = false;

		// cURL
		if (extension_loaded('curl')) {
			// Init cURL
			$ch = @curl_init();
			
			// Set options
			@curl_setopt($ch, CURLOPT_URL, $url);
			@curl_setopt($ch, CURLOPT_HEADER, 0);
			@curl_setopt($ch, CURLOPT_FAILONERROR, 1);
			@curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			@curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
			
			// Set timeout
			@curl_setopt($ch, CURLOPT_TIMEOUT, 5);
			
			// Grab data
			$data = @curl_exec($ch);
			
			// Clean up
			@curl_close($ch);
			
			// Return data
			if ($data !== false) {
				return $data;
			}
		}

		// fsockopen
		if (function_exists('fsockopen')) {
			$errno = 0;
			$errstr = '';
			
			$url_info = parse_url($url);
			if($url_info['host'] == 'localhost')  {
				$url_info['host'] = '127.0.0.1';
			}

			// Set timeout
			$fsock = @fsockopen($url_info['scheme'].'://'.$url_info['host'], 80, $errno, $errstr, 5);
		
			if ($fsock) {
				@fputs($fsock, 'GET '.$url_info['path'].(!empty($url_info['query']) ? '?'.$url_info['query'] : '').' HTTP/1.1'."\r\n");
				@fputs($fsock, 'HOST: '.$url_info['host']."\r\n");
				@fputs($fsock, "User-Agent: ".$useragent."\n");
				@fputs($fsock, 'Connection: close'."\r\n\r\n");
		
				// Set timeout
				@stream_set_blocking($fsock, 1);
				@stream_set_timeout($fsock, 5);
				
				$data = '';
				$passed_header = false;
				while (!@feof($fsock)) {
					if ($passed_header) {
						$data .= @fread($fsock, 1024);
					} else {
						if (@fgets($fsock, 1024) == "\r\n")
							$passed_header = true;
					}
				}
				
				// Clean up
				@fclose($fsock);
				
				// Return data
				if ($data !== false) {
					return $data;
				}
			}
		}

		// fopen
		if (function_exists('fopen') && ini_get('allow_url_fopen')) {
			// Set timeout
			if (ini_get('default_socket_timeout') < 5) {
				ini_set('default_socket_timeout', 5);
			}
			@stream_set_blocking($handle, 1);
			@stream_set_timeout($handle, 5);
			@ini_set('user_agent',$useragent);
			
			$url = str_replace('://localhost', '://127.0.0.1', $url);
			
			$handle = @fopen ($url, 'r');
			
			if ($handle) {
				$data = '';
				while (!feof($handle)) {
					$data .= @fread($handle, 8192);
				}
				
				// Clean up
				@fclose($handle);
			
				// Return data
				if ($data !== false) {
					return $data;
				}
			}
		}
		
		// file_get_contents
		if(function_exists('file_get_contents') && ini_get('allow_url_fopen')) {
			$url = str_replace('://localhost', '://127.0.0.1', $url);
			@ini_set('user_agent',$useragent);
			$data = @file_get_contents($url);
			
			// Return data
			if ($data !== false) {
				return $data;
			}
		}
		
		return $data;
	}
}	